> For the complete documentation index, see [llms.txt](https://docs.tokensfarm.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tokensfarm.com/for-developers/perpetualtokensfarm/withdraw.md).

# Withdraw

&#x20;WITHDRAW SYSTEM : You can withdraw in two ways \
\
• You can withdraw stake + rewards for that stake in one go\
&#x20;   1\. If `coolDown == 0` user can call `withdraw` and immediately withdraw

```solidity
function withdraw(
    uint256 _amount,
    uint256 stakeId
)
```

&#x20;2\. if `coolDown > 0` user needs to first initiate withdraw request calling makeWithdrawRequest

```solidity
function makeWithdrawRequest(
    uint256 _amount,
    uint256 stakeId
)
```

&#x20; After coolDown period has passed user will initiate withdraw&#x20;

```solidity
function withdraw(
    uint256 _amount,
    uint256 stakeId
)id
```

\
• You can only withdraw earned rewards for all stakes by user calling&#x20;

```solidity
function withdrawRewards()
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tokensfarm.com/for-developers/perpetualtokensfarm/withdraw.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
